local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local spec
local _

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.TimeToDie = s.TimeToDie("target") or 10
	_, x.GCD = s.GlobalCooldown()
	x.Focus = s.Power("player", SPELL_POWER_FOCUS)
	spec = s.Spec()
	a.Flash("Aspect of the Hawk", "Aspect of the Cheetah while moving")
	a.Flash("Hunter's Mark")
	a.Flash("Call Pet")
	a.Flash("Mend Pet")
	a.Flash("Pet Attack")
	a.Flash("Pet Assist")
	a.Flash("Silencing Shot")
	a.Flash("Concussive Shot")
	a.Flash("Disengage")
	a.Flash("Feign Death")
	a.Flash("Master's Call")
	a.Flash("Widow Venom")
	a.Flash("Exhilaration")
	x.Bloodlust = a.Bloodlust()
	x.RapidFire = s.Buff(3045--[[Rapid Fire]], "player")
	if spec == 1 then
		-- BM
		a.Flash("Potion with Bloodlust or TTD <= 60",
		        "Auto Shot",
		        "Explosive Trap (AoE)",
		        "Focus Fire at 5 stacks",
				"Serpent Sting if not ticking",
				"Fervor with focus <= 65",
				"Bestial Wrath if focus > 60",
				"Multi-Shot (AoE)",
				"Cobra Shot (AoE)",
				"Rapid Fire",
				"Stampede w/ Rapid Fire or Bloodlust",
				"Kill Shot",
				"Kill Command",
				"A Murder of Crows",
				"Glaive Toss",
				"Lynx Rush",
				"Dire Beast when focus <= 90",
				"Barrage",
				"Powershot",
				"Blink Strike",
				"Readiness after Rapid Fire",
				"Arcane Shot with Thrill of the Hunt",
				"Cobra Shot if SS < 6",
				"Arcane Shot if focus >= 69 or The Beast Within up",
				"Cobra Shot BM")
	elseif spec == 2 then
		-- MM
		if (s.HealthPercent("target") <= 80 or s.Dummy("target")) then
			a.Flash("Potion with Bloodlust or TTD <= 60",
					"Auto Shot",
					"Explosive Trap (AoE)",
					"Powershot",
					"Blink Strike",
					"Lynx Rush",
					"Multi-Shot (AoE)",
					"Steady Shot (AoE)",
					"Fervor with focus <= 50",
					"Rapid Fire",
					"Stampede w/ Rapid Fire or Bloodlust",
					"A Murder of Crows",
					"Dire Beast",
	-- without CA
					"Glaive Toss",
					"Barrage",
					"Steady Shot with Pre Steady Focus and Steady Focus <= 5",
					"Serpent Sting if not ticking",
					"Chimera Shot",
					"Readiness after Rapid Fire",
					"Steady Shot if Steady Focus < Cast Time",
					"Kill Shot",
					"Aimed Shot with Master Marksman",
					"Arcane Shot with Thrill of the Hunt",
					"Aimed Shot when hasted",
					"Arcane Shot as focus dump when not hasted",
					"Steady Shot")
		else
			a.Flash("Potion with Bloodlust or TTD <= 60",
					"Auto Shot",
					"Explosive Trap (AoE)",
					"Powershot",
					"Blink Strike",
					"Lynx Rush",
					"Multi-Shot (AoE)",
					"Steady Shot (AoE)",
					"Fervor with focus <= 50",
					"Rapid Fire",
					"Stampede w/ Rapid Fire or Bloodlust",
					"A Murder of Crows",
					"Dire Beast",
	-- with CA
					"Serpent Sting if not ticking",
					"Chimera Shot",
					"Readiness after Rapid Fire",
					"Steady Shot with Pre Steady Focus and Steady Focus < 6",
					"Aimed Shot",
					"Steady Shot")
		end
	elseif spec == 3 then
		-- SV
		a.Flash("Potion with Bloodlust or TTD <= 60",
		        "Auto Shot",
		        "Explosive Trap (AoE)",
				"A Murder of Crows",
				"Blink Strike",
				"Lynx Rush",
				"Explosive Shot with Lock and Load",
				"Glaive Toss",
				"Powershot",
				"Barrage",
				"Multi-Shot (AoE)",
				"Cobra Shot (AoE)",
				"Serpent Sting if not ticking and TTD  >= 10",
				"Explosive Shot",
				"Kill Shot",
				"Black Arrow if not ticking and TTD  >= 8",
				"Multi-Shot with Thrill of the Hunt and SS < 2",
				"Arcane Shot with Thrill of the Hunt",
				"Rapid Fire",
				"Dire Beast",
				"Stampede w/ Rapid Fire or Bloodlust",
				"Readiness after Rapid Fire",
				"Fervor with focus <= 50",
				"Cobra Shot if SS < 6",
				"Arcane Shot if focus >= 67",
				"Cobra Shot SV")
	end
end)

